world
	name = "Volte's 3D thing"
	turf = /turf/ground
	view = "16x16"
turf/ground
	icon = 'background.dmi'

obj/hands
	icon = 'hands.dmi'
	screen_loc = "3,1"
	layer = 50
obj/map_item
	layer = 49
obj/items/ladder/icon = 'hole.dmi'
obj/items/ladder_up/icon = 'ladder.dmi'
turf/wall
	icon = 'map_icons.dmi'
	icon_state = "wall"
	density = 1

obj/Compass
		icon = 'Compass.dmi'
		screen_loc = "6,6"
		layer = 111
obj/hand/layer = 50
obj/background
		icon = 'background.dmi'
		screen_loc = "1,1 to 6,3"
		layer = MOB_LAYER
obj/sky
	icon = 'background.dmi'
	icon_state = "sky"
	screen_loc = "1,4 to 6,6"
	layer = MOB_LAYER
obj/walls/wall/layer = MOB_LAYER+1
mob/Login()
		..()
		src.client.screen += new/obj/background
		src.client.screen += new/obj/sky
		src.client.screen += new/obj/Compass
		src.client.screen += new/obj/hands
		src.Move(locate(9,6,2))
		src.dir = 1
		for(var/obj/Compass/C in client.screen) C.icon_state = num2text(src.dir)
client
	East()
		mob.dir = turn(mob.dir,-90)
		Generate_Walls(mob)
		for(var/obj/Compass/C in screen) C.icon_state = num2text(mob.dir)
	West()
		mob.dir = turn(mob.dir,90)
		Generate_Walls(mob)
		for(var/obj/Compass/C in screen) C.icon_state = num2text(mob.dir)
	North()
		step(mob,mob.dir)
		Generate_Walls(mob)
	South()
		return
	Northeast()
		return
	Northwest()
		return
	Southeast()
		return
	Southwest()
		return
proc/check(var/T)
		if(istype(T,/turf/wall)) return 1
		else return 0
mob/verb
	Down()
		if(locate(/obj/items/ladder) in usr.loc)
			usr << "You climb down the hole."
			usr.z--;Generate_Walls(usr)
	Up()
		if(locate(/obj/items/ladder_up) in usr.loc)
			usr << "You climb up the ladder."
			usr.z++;Generate_Walls(usr)
mob/icon = 'mob.dmi'
obj/wall_obj
mob
	Move()
		..()
		for(var/mob/M in oview(2))
			if(M.client) Generate_Walls(M)

client

	New()
		..()
		var/obj/wall_obj/O
		for(var/i=1,i<7,i++)
			for(var/j=1,j<7,j++)
				O = new()
				screen += O
				O.screen_loc = "[i],[j]"
				mob.display_list[i][j] = O
				O.layer = 110
		Generate_Walls(mob)
mob/var/display_list[] = new(6,6)
proc
	Generate_Walls(mob/M as mob)
		for(var/obj/wall_obj/O in M.client.screen) O.icon_state = ""
		for(var/obj/wall_obj/O in M.client.screen)
			for(var/T in O.overlays) O.overlays -= T
		var/forward_right=get_step(M,turn(M.dir,-90))
		var/forward_left = get_step(M,turn(M.dir,90))
		var/forward_right1 = get_step(forward_right,M.dir)
		var/forward_left1 = get_step(forward_left,M.dir)
		var/forward_right_wall = get_step(M,turn(M.dir,-45))
		var/forward_left_wall = get_step(M,turn(M.dir,45))
		var/forward = get_step(M,M.dir)
		var/forward2 = get_step(forward,M.dir)
		var/forward2_left = get_step(forward2,turn(M.dir,90))
		var/forward2_right = get_step(forward2,turn(M.dir,-90))
		if(!check(forward2))
			if(check(forward2_left))
				Make_Wall('back.dmi',M)
				Make_Wall('back_corner.dmi',M)
			if(check(forward2_right))
				Make_Wall('back_right.dmi',M)
				Make_Wall('back_right_corner.dmi',M)
		if(check(forward2))
			Make_Wall('center3.dmi',M)
			if(check(forward2_right)&&!check(forward_right_wall)) Make_Wall('back_right.dmi',M)
			if(check(forward2_left)&&!check(forward_left_wall)) Make_Wall('back.dmi',M)
		if(!check(forward)&&!check(forward2))
			Make_Wall('out_of_range.dmi',M)
		if(!check(forward2_left)) Make_Wall('out_of_range_left.dmi',M)
		if(!check(forward2_right)) Make_Wall('out_of_range_right.dmi',M)
		if(check(forward_left)) Make_Wall('front.dmi',M,"0")
		if(check(forward_right)) Make_Wall('front.dmi',M,"5")
		if(check(forward_left1)) Make_Wall('center2.dmi',M,"1")
		if(check(forward_right1)) Make_Wall('center2.dmi',M,"4")
		if(check(forward_right_wall)&&!check(forward_right)) Make_Wall('center2.dmi',M,"5")
		if(check(forward_left_wall)&&!check(forward_left)) Make_Wall('center2.dmi',M,"0")
		if(check(forward))
			Make_Wall('center.dmi',M)
			if(!check(forward_right)) Make_Wall('center2.dmi',M,"5")
			if(!check(forward_left)) Make_Wall('center2.dmi',M,"0")
		for(var/obj/items/L in forward)
			Make_Object(L.icon,M)
			break
		for(var/mob/Mo in forward)
			Make_Object('mob.dmi',M)
			break
		if(!check(forward))
			for(var/mob/Mo in forward2)
				Make_Object('mob2.dmi',M)
				break

mob/verb/Test2()
	Generate_Walls(usr)
proc
	Make_Object(var/I as icon,mob/M as mob)
		var/obj/tempobj
		for(var/S in icon_states(I))
			var/first_num = text2num(copytext(S,1,2))
			var/second_num = text2num(copytext(S,3,4))
			tempobj = M.display_list[first_num+1][second_num+1]
			tempobj.overlays += icon(I,"[first_num],[second_num]")
	Make_Wall(I as icon,mob/M as mob,first_letter as text)
		var/obj/tempobj
		if(first_letter)
			for(var/S in icon_states(I))
				if(copytext(S,1,2)==first_letter)
					var/first_num = text2num(copytext(S,1,2))
					var/second_num = text2num(copytext(S,3,4))
					tempobj = M.display_list[first_num+1][second_num+1]
					tempobj.icon = I
					tempobj.icon_state = "[first_num],[second_num]"
		else
			for(var/S in icon_states(I))
				var/first_num = text2num(copytext(S,1,2))
				var/second_num = text2num(copytext(S,3,4))
				tempobj = M.display_list[first_num+1][second_num+1]
				tempobj.icon = I
				tempobj.icon_state = "[first_num],[second_num]"
mob/var/list/display_objects = new()





